import java.io.*;
import java.util.*;
import java.sql.*;

/*This Program contains several small methods used in other programs
  This includes methods  to find groups to which a user belongs,
  find all users in a group,find roles corresponding to a user.
  and so on. In general, any function which is useful in providing info about
  the priviledges of a user and is going to be used by many other programs
  should be put here*/


public class Authenticator   {

	Connection conn;
	String query;
	ResultSet rset;
 	//Constructor	
	//Creates a JDBC connection for use by the entire program
	 public  Authenticator()
	 throws SQLException{
		try{
		DriverManager.registerDriver
		(new oracle.jdbc.driver.OracleDriver());
		conn = DriverManager.getConnection
		("jdbc:oracle:thin:@144.16.111.4:1521:GEN", "bando", "rccry289");
		} catch(SQLException e){
			System.out.println("SQL Exception");
		}
	
	 }
	 //Authenticate username and passwd
	 public  boolean authenticate(String uname,String pwd)
       	 throws SQLException{

		  Statement stmt = conn.createStatement();
		  query="select UserName  from users where Username ='" + uname +"' and Passwd = '" + pwd+"'" ;
    	    	  rset = stmt.executeQuery (query  );
		  if(rset.next())
		 	return(true);
		  return(false);	
	  }
	 //find all groups a user/group belongs to 
	 // For this use a BFS over the heirarchy dag
	public Vector findGroups(String uname)
	throws SQLException{
		  String tmpusr;
		  Statement stmt = conn.createStatement();
		  Vector queue=new Vector();
		  Vector retvec=new Vector();
		  //Implement BFS
		  //put 1st element in queue
		  queue.addElement(uname);	
    		  while (! queue.isEmpty()){
		  	tmpusr=(String)queue.firstElement();//pop queue
			//System.out.println(tmpusr);
			retvec.addElement(tmpusr);
		        query="select GroupName  from belongsTo where Username ='" + tmpusr +"'" ;
			rset=stmt.executeQuery(query);
			queue.removeElement(tmpusr);
			while(rset.next()){
				tmpusr=rset.getString(1);
				if(! queue.contains(tmpusr))
					queue.addElement(tmpusr);
			}
		} 
		return(retvec);
	}
	//Find all single-user members of a group
	//This again is a breadth-first search
	public Vector findMembers(String gname)
	throws SQLException{
		  String tmpgrp;
		  Statement stmt = conn.createStatement();
		  Vector queue=new Vector();
		  Vector retvec=new Vector();
		 //put 1st element in queue
		  queue.addElement(gname);	
    		  while (! queue.isEmpty()){
		  	tmpgrp=(String)queue.firstElement();//pop queue
			//Select all children and push into queue
		        query="select UserName  from belongsTo where GroupName ='" + tmpgrp +"'" ;
			rset=stmt.executeQuery(query);
			queue.removeElement(tmpgrp);
			if(!rset.next()){
				retvec.addElement(tmpgrp);
				continue;
			}	
			do{
				tmpgrp=rset.getString(1);
				if(! queue.contains(tmpgrp))
					queue.addElement(tmpgrp);
			}while(rset.next());
		}
		return(retvec);
	  }
	  
	  //Is a user allowed a particular role ?
	  //This will hold if any group to which the user belongs is also
	  //granted that role.
	  public boolean checkRole(String uname,String rname)
	  throws SQLException{
		Statement stmt = conn.createStatement();
	  	Vector groupvec=findGroups(uname);
		String utmp;
		while(! groupvec.isEmpty()){
			utmp=(String)groupvec.firstElement();
			groupvec.removeElement(utmp);
			query="Select UserName from isA where UserName='"+utmp+"' and RoleName='"+rname+"'";
			rset=stmt.executeQuery(query);
			if(rset.next())  return(true);
		}
		return(false);
	}
	//is a user allowed a role wrt another user?
	  //This will hold if any group to which the user belongs is also
	  //granted that role on any group containing second user
	  public boolean checkRole(String uname1,String rname,String uname2)
	  throws SQLException{
		Statement stmt = conn.createStatement();
	  	Vector groupvec1=findGroups(uname1);
	  	Vector groupvec2=findGroups(uname2);
		String utmp1,utmp2;
		while(! groupvec1.isEmpty()){
			utmp1=(String)groupvec1.firstElement();
			groupvec1.removeElement(utmp1);
			while( !groupvec2.isEmpty()){
				utmp2=(String)groupvec2.firstElement();
				groupvec2.removeElement(utmp2);
				query="Select UserName from isA where UserName='"+utmp1+"' and RoleName='"+rname+"' and RegardTo='"+utmp2+"'";
				rset=stmt.executeQuery(query);
				if(rset.next())  return(true);
			}
		}
		return(false);
	}
	//Does a role have grant perms?
	public boolean isGrantable(String rname)
	throws SQLException{
		Statement stmt = conn.createStatement();
		query="Select GrantOp from roles where RoleName='"+rname+"'";
		rset=stmt.executeQuery(query);
		if(rset.next() ){
			if (rset.getInt(1)==1)
				return(true);
		}
		return(false);
	}	
		
	//find all the roles a user/group can have. This includes all the 
	// roles granted to the user/group and all supersets of that user/group
	public Vector findRoles(String uname)
	throws SQLException{
		Statement stmt = conn.createStatement();
		Vector groupvec=findGroups(uname);
		Vector retvec=new Vector();
		String utmp;
		while(! groupvec.isEmpty()){
			utmp=(String)groupvec.firstElement();
			groupvec.removeElement(utmp);
			query="Select RoleName from isA where Username='"+utmp+"'";
			rset=stmt.executeQuery(query);
			while(rset.next())
				retvec.addElement(rset.getString(1));
		}
		return(retvec);
	}	
	public Vector findRolesPairs(String uname)
	throws SQLException{
		Statement stmt = conn.createStatement();
		Vector groupvec=findGroups(uname);
		Vector retvec=new Vector();
		String utmp;
		while(! groupvec.isEmpty()){
			utmp=(String)groupvec.firstElement();
			groupvec.removeElement(utmp);
			query="Select RoleName,RegardTo from isA where Username='"+utmp+"'";
			rset=stmt.executeQuery(query);
			while(rset.next()){
				retvec.addElement(rset.getString(1));
				retvec.addElement(rset.getString(2));
			}	
		}
		return(retvec);
	}
	public Vector findUsers()
	throws SQLException{
		Statement stmt = conn.createStatement();
		Vector retvec=new Vector();
	 	query="Select UserName from users";
		rset=stmt.executeQuery(query);
		while(rset.next())
			retvec.addElement(rset.getString(1));
		return(retvec);
	}	
}	
