create table users (
	UserName  varchar(20) primary key,
	Passwd 	 varchar(15) not null
);

create table roles (
	RoleName varchar(20) primary key,
	RoleDesc varchar(50),
	GrantOp  Number(1) not null,
	constraint grn_ck check( GrantOp <=1 and GrantOp >=0)
);

create table groups (
	GroupName varchar(20) primary key,
	GroupDesc varchar(50)
);


create table isA (
	UserName varchar(20) not null,
	constraint User1_fk  foreign key (UserName)
	references users(UserName),
	RoleName varchar(20) not null,
	constraint Role_fk  foreign key (RoleName)
	references roles(RoleName),
	RegardTo varchar(20),
	constraint Reg_fk  foreign key (RegardTo)
	references groups(GroupName)
);

create table belongsTo (
	UserName varchar(20) not null,
	GroupName varchar(20),
	constraint Grp_fk  foreign key (GroupName)
	references groups(GroupName)
);	
	
	
insert into groups values ('btech3',NULL);
insert into groups values ('btech4',NULL);
insert into groups values ('student',NULL);
insert into groups values ('faculty',NULL);
insert into groups values ('cse',NULL);
insert into groups values ('employee',NULL);
insert into groups values ('part-time',NULL);

insert into users values('ashish','ashish');
insert into users values('bando','bando');
insert into users values('kinit','kinit');
insert into users values('jatin','jatin');
insert into users values('anshul','anshul');
insert into users values('sb','sb');
insert into users values('sud','sud');
insert into users values('siva','siva');

insert into belongsTo values('ashish','btech3');
insert into belongsTo values('bando','btech3');
insert into belongsTo values('kinit','part-time');
insert into belongsTo values('jatin','btech4');
insert into belongsTo values('anshul','btech4');
insert into belongsTo values('sb','faculty');
insert into belongsTo values('sud','faculty');
insert into belongsTo values('siva','faculty');
insert into belongsTo values('btech3','student');
insert into belongsTo values('btech4','student');
insert into belongsTo values('student','cse');
insert into belongsTo values('faculty','employee');
insert into belongsTo values('part-time','employee');
insert into belongsTo values('part-time','student');
insert into belongsTo values('employee','cse');



insert into roles values ('facad',NULL,0);
insert into roles values ('classrep',NULL,1);

insert into isA  values ('sb','facad','btech3');
insert into isA  values ('siva','facad','btech4');
insert into isA  values ('bando','classrep','btech3');
insert into isA  values ('jatin','classrep','btech4');
